<template>
    <div>
        <div :class="['alert', alertType, 'alert-flash']" role="alert" v-show="show">
                <span v-html="body"></span>
        </div>
    </div>
</template>

<script>
    import Swal from 'sweetalert2'

    export default {
        props : ['type','message'],
        data()
        {
            return{
                body : "",
                periodTime: 1500,
                show : false,
                alert_type : "primary"
            }
        },
        computed:
         {
            alertType()
            {
               return "alert-"+this.alert_type
            }
        },
        mounted() {

            if(this.message)
            {
                this.flash(this.message,this.type == undefined ? "primary" : this.type)

            }

            window.event.$on("flash",(message) =>
            {
                if(message.type)
                {
                     
                    this.flash(message.message,message.type)
                }
                else
                this.flash(message.message)
            });

           
        },
        methods:
        {
            flash(message,type="success")
            {
                const Toast = Swal.mixin({
                toast: true,
                position: 'top-end',
                showConfirmButton: false,
                timer: 2000,
                timerProgressBar: true,
                onOpen: (toast) => {
                    toast.addEventListener('mouseenter', Swal.stopTimer)
                    toast.addEventListener('mouseleave', Swal.resumeTimer)
                }
                })

                Toast.fire({
                icon:  type,
                title: message
                })
               
            },
            hide()
            {
                setTimeout(() => 
                {
                    this.show = false
                  
                },this.periodTime)
            }
            
        }
    }
</script>
<style <style lang="scss">
   .alert-flash
   {

   }
</style>

